<template>
  <div>
    <h3>
      <nuxt-link :to="`/courses/${$route.params.uuid}`">{{
        course.name
      }}</nuxt-link>
      : Leaderboard
    </h3>

    <h3>TODO: Currently not properly ordered...</h3>
    <ul>
      <li v-for="run in course.runs._">
        {{ run.user.name }} - {{ duration(run) | formatElapsed }} ({{
          run.checkins.totalCount
        }}
        checkpoints)
      </li>
    </ul>
  </div>
</template>
<script>
import { query } from "~/plugins/data-management";
import { get } from "~/lib/utils";

export default {
  asyncData: query(
    `query($first: Int,$offset: Int,$courseUUID: UUID!) {
  course:courseByUuid(uuid: $courseUUID) {
    name
    user:userByUserId {
      name
      id
    }
    
    runs:runsByCourseId(first:$first,offset:$offset) {
      totalCount
      _:nodes {
        id
        uuid
        courseId
        uniqueCheckinCount
        start

        user:userByUserId {
          name
        }

        events:runEventsByRunId {
          totalCount
        }

        firstEvent:runEventsByRunId(first:1) {
          _:nodes {
          	createdAt
          }
        }

        lastEvent:runEventsByRunId(last:1) {
          _:nodes {
          	createdAt
          }
        }
        
        checkins:checkinsByRunId { totalCount }
      }
    }
  }
}`,
    ({ query, params }) => ({
      first: (query.first && Number(query.first)) || 50,
      offset: query.offset && Number(query.offset),
      courseUUID: params.uuid,
    })
  ),
  methods: {
    duration(run) {
      const start = get(run, "firstEvent._.0.createdAt");
      const end = get(run, "lastEvent._.0.createdAt");

      if (start && end) {
        return (new Date(end) - new Date(start)) / 1000;
      }

      return 0;
    },
  },
};
</script>
